package acme;


/**
 * An instance of this class represent a worker in a company.
 * @inv getName() != null
 */
public class Worker {
	private String m_name;
	private Department m_department;
	
	public Worker(String name) {
		m_name = name;
	}
	
	/**
	 * @return the name of the worker (should be unique)
	 */
	public String getName() {
		return m_name;
	}
	

	public boolean equals(Worker otherWorker) {
		return getName().equals(otherWorker.getName());
	}
	/**
	 * 
	 * @return the department to which the worker belong
	 */
	public Department getDepartment() {
		return m_department;
	}

	/**
	 * Update the worker to be in the given department.
	 * @param department
	 */
	public void setDepartment(Department department) {
		if (m_department != department) {
			if (m_department != null) {
				m_department.removeWorker(this);
			}
			m_department = department;
		}
	}

	public String toString() {
		return getName();
	}
}
